> module BachStat where
> import GrammarMonad 
> import GrammarRules
> import System.Random
> import Learning
> import PCFGtoPTGG
> import Rohrmeier hiding (S)
> import ChordSpaces hiding (i)
> import Data.List
> import Euterpea

> rs = [I,II,III,IV,V,VI,VII]

> singleStats m = do
>     s <- readFile "BachChords.txt"
>     let dstr = concatMap (\(a,b,c) -> c) $ filter (\(a,b,c) -> b==m) $ parseData s
>         counts = map (\x -> length $ filter (==x) dstr) rs
>     writeFile ("BachStatsSingle_"++show m++".txt") (concat $ intersperse "\n" $ map show counts)
>     putStrLn "Done."

> readSingle :: IO [Int]
> readSingle = readFile "BachStatsSingle.txt" >>= (return . map read . lines)

> pairStats m = do 
>     s <- readFile "BachChords.txt"
>     let dstrs = map (\(a,b,c) -> c) $ filter (\(a,b,c) -> b==m) $ parseData s
>         pats = [(a,b) | a<-rs, b<-rs]
>         counts = map (\p -> sum $ map (countPairs p) dstrs) pats
>     writeFile ("BachStatsPairs_"++show m++".txt") (concat $ intersperse "\n" $ map show $ zip pats counts)
>     putStrLn "Done."


> pairStatsRare c m = do 
>     s <- readFile "BachChords.txt"
>     let dstrs = map (\(a,b,c) -> c) $ filter (\(a,b,c) -> b==m) $ parseData s
>         pats = [(a,b) | a<-rs, b<-rs]
>         counts = map (\p -> sum $ map (countPairs p) dstrs) pats
>         cps = zip pats counts
>         cps' = filter ((<c).snd) cps
>     writeFile ("BachStatsPairs_"++show m++"_less"++show c++".txt") (concat $ intersperse "\n" $ map show cps')
>     putStrLn "Done."

> countPairs :: (Eq a) => (a,a) -> [a] -> Int
> countPairs (a,b) (x:y:t) = (if a==x && b==y then 1 else 0) + countPairs (a,b) (y:t)
> countPairs _ _ = 0