> module FGTypes where
> import GrammarMonad
> import GrammarRules
> import GrammarRulesV
> import System.Random
> import Euterpea
> import ChordSpaces
> import PostProc
> import Data.List

> data TNote2 = TNote2 {tkey :: Key,
>                       tdur :: Dur,
>                       beat :: Dur,
>                       isLast :: Bool,
>                       ap :: AbsPitch}
>     deriving (Eq, Show, Ord)

> toTN2 :: Dur -> Bool -> TChord -> [TNote2]
> toTN2 o l (k,d,as) = map (\a -> TNote2 k d o l a) as

> toTN1 :: TNote2 -> TNote
> toTN1 t = (tkey t, tdur t, ap t)

> backToVoices :: [[TNote2]] -> [Voice]
> backToVoices = map (map toTN1)

> toTNote2 :: [TChord] -> [[TNote2]]
> toTNote2 tcs = Data.List.transpose $ fRec tcs 0 where
>     fRec [] dSum = []
>     fRec (x@(k,d,as):xs) dSum = toTN2 dSum (null xs) x : fRec xs dSum