> {-# OPTIONS_GHC -XBangPatterns #-}

> module InOut where
> import Data.List
> import CykParser
> import Parser hiding (testStr, testStr2)
> import System.Random
> import Control.Parallel.Strategies

Donya Quick
Last modified: 20-Dec-2013

CHANGES:
- Modified to handle multiple strings
- Modified to handle A -> BCD
- Modified to handle A -> B synonyms - NEED TO CHECK THIS AT START SYM LEVEL
- Modified to allow for minimum production probs
- Removed redundant parse tables from type signatures of Env/EnvM
- Added support for A -> A identity rules.

CONSTANTS

> minProb = 0.00001 -- set to >0 to avoid zero probability rules 


Potential function. This must be in [0,1] and will need
to be initialized somehow.

phi(a -> BC, i, k, j)

 type PFun a = Rule a -> Int -> Int -> Int -> Double
 
> -- type PFun a = Rule a -> Double
> -- type PTable a = [[[a]]]

The environment consists of a list of rules, a parse table, 
and the string associated with that parse table, and a phi 
function (potential function), and a start symbol.

Environment:
- list of rules
- start symbol
- strings that produced the table
- potential function phi

> type Env a = ([Rule a], a, [a], [Double]) 
> type EnvM a = ([Rule a], a, [[a]], [Double])

> type Alpha a = ((a, Int, Int), Double)
> type Beta a = ((a, Int, Int), Double)

> -- phi :: (Eq a) => Rule a -> Double -> a -> [a] -> Double
> phi (rules, phis, lhs, rhs) = case findIndex (==(lhs,rhs)) rules of
>     Just i -> phis !! i
>     Nothing -> error "No such rule!" 0.0 -- should it be an error case?

> alpha :: (Eq a) => [Alpha a] -> Env a -> a -> Int -> Int -> Double
> alpha as env@(rules, s, xs, phis) a i j = 
>     let inTerms b c k = prod [phi (rules, phis, a, [b,c]), alpha as env b i k, 
>                         alpha as env c (k+1) j]
>         fixPhi = 1.0 -- if elem (a,[a]) rules then phi (rules, phis, a, [a]) else 1.0 -- CORRECT?????????
>         inSum [b] = prod [phi (rules, phis, a,[b]), alpha as env b i j, fixPhi]
>         inSum [b,c] = sum $ map (inTerms b c) [i..j-1]
>         inSum [b,c,d] = sum $ map (\(k,l) -> 
>                         prod [phi (rules, phis, a, [b,c,d]), alpha as env b i k, 
>                         alpha as env c (k+1) l, alpha as env d (l+1) j])
>                         [(k,l) | k<-[i..j], l<-[i..j], k<l, l<j]
>         retVal = if i==j && xs!!i == a then 1.0
>                      -- ALTERED, "TERMINAL" CASE
>                      --(if elem (a, [a]) rules then phi (rules, phis, a,[a]) else 1.0)  -- 1.0 OK??????????
>                  else sum $ map inSum [x | (lhs,x) <- rules, lhs==a, [lhs] /= x] -- IS LAST CRITERIA RIGHT?????????
>     in  case lookup (a,i,j) as of Nothing -> retVal
>                                   Just p -> p

Old code for the above:
if terminal rules a && i==j && xs!!i == a then 1.0 -- ADDED CASE. OK????
else sum $ map inSum [x | (lhs,x) <- rules, lhs==a]


> terminal :: (Eq a) => [Rule a] -> a -> Bool
> terminal rs x = null $ filter (\(l,r) -> l==x) rs

> alpha3 :: (Eq a) => [Alpha a] -> Env a -> a -> Int -> Int -> Double
> alpha3 = alpha

> distComp (x,a,b) (y,c,d) = compare (b-a) (d-c)

> makeAlphas :: (Eq a) => Env a -> [Alpha a]
> makeAlphas env@(rules, s, xs, phis) = 
>     let n = length xs
>         ijs = [(i,j) | i<-[0..n-1], j<-[0..n-1], i<=j]
>         aijs = reverse $ sortBy distComp [(a,i,j) | a<-nub (map fst rules), (i,j)<-ijs]
>     in  recAlpha env [] aijs where
>     recAlpha env alphas [] = alphas
>     recAlpha env alphas (x@(a,i,j):xs) = 
>         let aNew = alpha alphas env a i j
>         in  recAlpha env ((x,aNew):alphas) xs

> makeAlphasM :: (Eq a) => EnvM a -> [[Alpha a]]
> makeAlphasM env@(rules, s, xs, phis) = 
>     let f x = makeAlphas (rules, s, x, phis)
>     in  map f xs


=========

Betas

> beta :: (Eq a, Show a) => [Alpha a] -> [Beta a] -> Env a -> a -> Int -> Int -> Double
> beta as bs env@(rules, s, xs, phis) a i j = 
>     let n = length xs -- correct???
>         inTerms1 b c k = prod [phi (rules, phis, b, [c,a]), alpha3 as env c k (i-1), 
>                          beta3 as bs env b k j]
>         inTerms2 b c k = prod [phi (rules, phis, b, [a,c]), alpha3 as env c (j+1) k, 
>                          beta3 as bs env b i k]
>         inTerms3 b = prod [phi (rules, phis, b, [a]), beta3 as bs env b i j, fixPhi] -- CORRECT????????
>         fixPhi = 1.0 -- if elem (a,[a]) rules then phi (rules, phis, a, [a]) else 1.0 -- CORRECT?????????
>         inSum1 (b,c) = sum $ map (inTerms1 b c) [0..i-1] -- CHECK INDEXING
>         inSum2 (b,c) = sum $ map (inTerms2 b c) [j+1..n-1] -- CHECK INDEXING
>  --  USE OF SYNONYM FUNCTION BELOW MAY OR MAY NOT BE CORRECT --
>     in  if i==0 && j == n - 1 && a==s then 1.0 -- if synonym rules s a then 1.0 else 0.0 
>         else sum (map inSum1 [(b,c) | (b,[c,a']) <- rules, a==a']) + 
>              sum (map inSum2 [(b,c) | (b,[a',c]) <- rules, a==a']) +
>              sum (map inTerms3 [b | (b,[a']) <- rules, a==a', b/=a']) -- ADAPTED LINE



> beta3 :: (Show a, Eq a) => [Alpha a] -> [Beta a] -> Env a -> a -> Int -> Int -> Double
> beta3 as bs env@(rules, s, xs, phis) a i j = 
>     let n = length xs 
>         inTerms1 b c d (l,k) = prod [phi (rules, phis, b, [c,d,a]), alpha3 as env c l (k-1), 
>                                alpha3 as env d k (i-1), beta3 as bs env b l j]
>         inTerms2 b c d (l,k) = prod [phi (rules, phis, b, [c,a,d]), alpha3 as env d (j+1) k,
>                                alpha3 as env c l (i-1), beta3 as bs env b l k]
>         inTerms3 b c d (l,k) = prod [phi (rules, phis, b, [a,c,d]), alpha3 as env d (l+1) k,
>                                alpha3 as env c (j+1) l, beta3 as bs env b i k]
>         lks1 = [(l,k) | l<-[0..n-1], k<-[0..n-1], l >= 0 && l<k && k<i]
>         lks2 = [(l,k) | l<-[0..n-1], k<-[0..n-1], l >= 0 && l<i && k>j]
>         lks3 = [(l,k) | l<-[0..n-1], k<-[0..n-1], l>j, k>l]
>         inSum1 (b,c,d) = sum $ map (inTerms1 b c d) lks1
>         inSum2 (b,c,d) = sum $ map (inTerms2 b c d) lks2
>         inSum3 (b,c,d) = sum $ map (inTerms3 b c d) lks3
>         retVal = if i==0 && j == n - 1 && a==s then 1.0 else
>              sum (map inSum1 [(b,c,d) | (b, [c,d,a']) <- rules, a==a']) + 
>              sum (map inSum2 [(b,c,d) | (b, [c,a',d]) <- rules, a==a']) +
>              sum (map inSum3 [(b,c,d) | (b, [a',c,d]) <- rules, a==a']) + 
>              beta as bs env a i j -- HANDLE LENGTH 2 AND 1
>    in   case lookup (a,i,j) bs of Nothing -> retVal 
>                                   Just p -> p 

> makeBetas :: (Eq a, Show a) => [Alpha a] -> Env a -> [Beta a]
> makeBetas as env@(rules, s, xs, phis) = 
>     let n = length xs
>         ijs = [(i,j) | i<-[0..n-1], j<-[0..n-1], i<=j]
>         aijs = sortBy distComp [(a,i,j) | a<-nub (map fst rules), (i,j)<-ijs]
>     in  recBeta as env [] aijs where
>     recBeta as env betas [] = betas
>     recBeta as env betas (x@(a,i,j):xs) = 
>         let bNew = beta as betas env a i j
>         in  recBeta as env ((x,bNew):betas) xs

> makeBetasM :: (Eq a, Show a) => [[Alpha a]] -> EnvM a -> [[Beta a]]
> makeBetasM as env@(rules, s, xs, phis) = 
>     let f x a = makeBetas a (rules, s, x, phis)
>     in  zipWith f xs as


========

Other stuff

> prod :: (Num a, Eq a) => [a] -> a
> prod [] = 1
> prod (x:xs) = if x==0 then 0 else x * prod xs


> getSyns :: (Eq a) => [Rule a] -> a -> [a]
> getSyns rs x = [r | (l,[r])<-rs, l==x]

> synSet :: (Eq a) => [Rule a] -> [a] -> [a]
> synSet rs xs = 
>     let xs' = nub (xs ++concatMap (getSyns rs) xs)
>     in  if length xs' == length xs then xs else synSet rs xs'

> synonym :: (Eq a) => [Rule a] -> a -> a -> Bool
> synonym rs x y = elem y $ synSet rs [x]


> z :: (Eq a) => [Alpha a] -> [Beta a] -> Env a -> Double -- CHECK INDEXING
> z as bs env@(rules, s, xs, phis) = alpha as env s 0 (length xs-1)

These will be used to calculate the mu values.


--== CONFIRM THAT MU IS OK WITH SYNONYMS ==--

> mu :: (Show a, Eq a) => [Alpha a] -> [Beta a] -> Env a -> Rule a -> Int -> Int -> Int -> Double
> mu as bs env@(rules, s, xs, phis) r@(a,[b]) i k j = 
>     if i==k || k==j then prod [beta3 as bs env a i j, phi(rules, phis, a, [b]), alpha3 as env b i j]
>     else error ("(mu) "++show (r,i,k,j))
> mu as bs env@(rules, s, xs, phis) r@(a,[b,c]) i k j = 
>     prod [beta3 as bs env a i j, phi(rules, phis, a, [b,c]), alpha3 as env b i k, alpha3 as env c (k+1) j]

> mu3 :: (Show a, Eq a) => [Alpha a] -> [Beta a] -> Env a -> Rule a -> Int -> Int -> Int -> Int -> Double
> mu3 as bs env@(rules, s, xs, phis) r i k l j = 
>     case r of (a,[b,c,d]) -> prod [phi (rules, phis, a, [b,c,d]), 
>                              beta3 as bs env a i j, alpha3 as env b i k,
>                              alpha3 as env c (k+1) l, alpha3 as env d (l+1) j]
>               _ -> mu as bs env r i k j 


0 ... [i...j] [j+1...k] [k+1...l] ... n-1


--== CONFIRM THAT COUNT IS OK WITH SYNONYMS ==--

-- COUNT NEEDS TO ADDRESS A->A

	 
> count as bs env@(rules, s, xs, phis) r@(a,[b]) = let n = length xs in
>     sum (map (\(i,j) -> mu as bs env r i i j ) [(i,j) | i<-[0,n-1], j<-[0..n-1], i<=j]) / z as bs env
> count as bs env@(rules, s, xs, phis) r@(a,[b,c]) = 
>     let n = length xs
>         term (i, k, j) = mu as bs env r i k j / z as bs env
>         triples = [(i,k,j) | i<-[0..n-2], k<-[0..n-1], j<-[1..n-1], i <= k && k < j]
>     in  sum $ map term triples
> count as bs env@(rules, s, xs, phis) r@(a,[b,c,d]) = --ADDED CASE
>     let n = length xs
>         term (i, k, l, j) = mu3 as bs env r i k l j / z as bs env 
>         quads = [(i,k,l,j) | i<-[0..n-2], k<-[0..n-1], l<-[0..n-1], 
>                    j<-[1..n-1], i <= k && k<l && l < j]
>     in  sum $ map term quads
> count as bs env r = error ("(count) Badly formed rule: "++show r)


> fLast :: (Show a, Eq a) => [[Alpha a]] -> [[Beta a]] -> EnvM a -> Rule a -> Double
> fLast as bs env@(rules, s, xs, phis) r = 
>     let --envs = zipWith (\t x -> (rules, s, t, x, phi)) ptables xs
>         envs = map (\str -> (rules, s, str, phis)) xs
>         exprs = map (\(a,b,e) -> count a b e r) $ zip3 as bs envs
>     in  sum $ seq (as, bs, envs) (exprs `using` parList rdeepseq) -- zipWith3 (\a b e -> count a b e r) as bs envs



> newQ :: (Eq a, Show a) => [Alpha a] -> [Beta a] -> Env a -> Rule a -> Double
> newQ as bs e@(rules, s, xs, phis) r@(lhs,rhs) = 
>     let f rx = count as bs e rx -- WILL NEED TO UPDATE TO HANDLE MULTIPLE STRINGS
>         rs = filter (\(lhs',rhs') -> lhs == lhs') rules -- CHECK CORRECTNESS
>     in  f r / sum (map f rs)

> newQ' :: (Eq a, Show a) => [[Alpha a]] -> [[Beta a]] -> EnvM a -> Rule a -> Double
> newQ' as bs e@(rules, s, xs, phis) r@(lhs,rhs) = 
>     let f rx = fLast as bs e rx 
>         rs = filter (\(lhs',rhs') -> lhs == lhs') rules -- CHECK CORRECTNESS
>         denom = sum (map f rs)
>     in  if denom == 0 then f r else f r / denom

NOTE: PHI DOESN'T NEED ITS INTEGER ARGUMENTS

 toPhi :: (Rule a -> Double) -> PFun
 toPhi qFun r i k j = qFun r

type Env a = ([Rule a], a, PTable a, [a], PFun a) 




TO-DO:
- Implement the rest of figure 3
- Confirm results on simple cases by hand

============
	 
> uniQs :: (Show a, Eq a) => [Rule a] -> [Double]
> uniQs rs = normalize 0.0 rs (let n = length rs in take n $ repeat (1))

> infRand :: StdGen -> [Double]
> infRand g = 
>     let (d,g') = randomR (0.0, 1.0) g
>     in  d : infRand g'

> --randQFun2 :: (Eq a) => StdGen -> [Rule a] -> PFun a
> randQFun2 g rules (l,r) =
>     let ds = take (length rules) (infRand g) -- get a bunch of random values
>         rds = zip rules ds
>         d = case findIndex (==(l,r)) rules of Just i -> snd (rds !! i)
>                                               Nothing -> 0.0 -- error "(randQFun) Rule not found!"
>         rs = filter (\((l',r'),d') -> l==l') rds
>         newDenom = sum (map snd rs)
>     in  d / newDenom
	 
> randQFun g rules = map (randQFun2 g rules) rules

============

> showTab :: (Show a) => [a] -> String
> showTab = concatMap ((++"\t").show)


This version writes the results to a file


> qsW fn fnq e i = qsNW fn fnq  [] e i

> qsNW :: (Eq a, Show a) => FilePath -> FilePath -> String -> EnvM a -> Int -> IO ()
> qsNW fn fnq str e@(r,s,strs,qf) i = do
>     let as = makeAlphasM e
>         bs = makeBetasM as e
>         qs0' = map (newQ' as bs e) r
>         qs' = if minProb > 0.0 then normalize minProb r qs0' else qs0'
>         qf' = qs' -- toQFun r qs'
>         newStr = str ++ "\n" ++ showTab (qs')
>         badInds = findIndices (\x -> x<=0) qs0'
>         badStr = if null badInds then "ok" else "Zero-prob rules: "++show badInds
>     if i <= 0 then writeFile fn (tabulate r qs') >> writeFile fnq str
>     else putStrLn (show qs') >> putStrLn badStr >>
>          qsNW fn fnq newStr (r,s,strs,qf') (i-1)

if i <= 0 then writeFile fn str else putStrLn (show qs') >> qsNW fn newStr (r,s,ts,strs,qf') (i-1)


> normalize :: (Eq a, Show a) => Double -> [Rule a] -> [Double] -> [Double]
> normalize minP rules vals =
>     let newVals = map (\x -> if x < minP || x <= 0 then minP else x) vals 
>     in  map (norm2 (zip rules newVals)) (zip rules newVals) 

> norm2 :: (Eq a, Show a) => [(Rule a, Double)] -> (Rule a, Double) -> Double
> norm2 rules ((l,r), d) = 
>     let denom = sum $ map snd $ filter (\((l',r'), d') -> l==l') rules
>     in  if denom > 0 then d / denom else error ("(norm2) Bad rule: "++ show (l,r, d)) -- CHECK THIS


> tabulate :: Show a => [Rule a] -> [Double] -> String
> tabulate rs qs = 
>     let f (l,r) q = show l ++ " -> " ++ concatMap show' r ++ "\t" ++ show q ++"\n"
>     in  concat $ zipWith f rs qs

> show' :: (Show a) => a -> String
> show' = (++" ") . show


> totalDiff :: [Double] -> [Double] -> Double
> totalDiff d1 d2 = sum $ map abs $ zipWith subtract d1 d2 


The following is for use in a general monadic context.

> learnProbs' :: (Eq a, Show a) => EnvM a -> Int -> Double -> Double -> IO [[Double]]
> learnProbs' e@(r,s,strs,qf) i minP dThresh = if i<=0 then return [] else do
>     let as = makeAlphasM e
>     let bs = makeBetasM as e
>     putStrLn "Calculating production probs..."
>     let qs0 = qf -- map qf r 
>         qs1s = map (uncurry3 newQ' $! (as, bs, e)) r
>         qs1 = seq (as, bs, e) (qs1s `using` parList rdeepseq) -- parallelize computation of qs1
>         qf' = if minP > 0.0 then normalize minP r qs1 else qs1
>         e' = (r,s,strs,qf') 
>         diff = totalDiff qs0 qf'
>     putStrLn ("Total probability mass changed: "++show diff)
>     sequence $ map (\q -> putStr (show q ++ ", ")) qf' 
>     let badInds = findIndices (\x -> x<=0) qs1
>         badStr = if null badInds then "ok" 
>                  else "Zero-prob rules: "++show badInds
>         (iNext, skipping) = if diff <= dThresh then (0, True) else (i-1, False)
>         itrStr = if skipping then ("Q has converged with "++show (i-1)++" iterations left.")
>                  else ("Iterations left: "++show (i-1))
>     putStrLn itrStr
>     qNext <- learnProbs' e' iNext minP dThresh 
>     return (qf' : qNext)

> learnProbs :: (Eq a, Show a) => EnvM a -> Int -> Double -> IO [[Double]]
> learnProbs e@(r,s,strs,qf) i minP = if i<=0 then return [] else do
>     let as = makeAlphasM e
>     let bs = makeBetasM as e
>     putStrLn"Calculating production probs..."
>     let qs0 = qf -- map qf r 
>         qs1s = map (uncurry3 newQ' $! (as, bs, e)) r
>         qs1 = seq (as, bs, e) (qs1s `using` parList rdeepseq) -- parallelize computation of qs1
>         qf' = if minP > 0.0 then normalize minP r qs1 else qs1
>         --qf' = toQFun r qs'
>         e' = (r,s,strs,qf') 
>     sequence $ map (\q -> putStr (show q ++ ", ")) qf' 
>     let badInds = findIndices (\x -> x<=0) qs1
>         badStr = if null badInds then "ok" 
>                  else "Zero-prob rules: "++show badInds
>         (iNext, skipping) = if qs0 == qf' then (0, True) else (i-1, False)
>         itrStr = if skipping then ("Q has converged with "++show (i-1)++" iterations left.")
>                  else ("Iterations left: "++show (i-1))
>     putStrLn itrStr
>     qNext <- learnProbs e' iNext minP  
>     return (qf' : qNext)

> uncurry3 f (a,b,c) = f a b c



========================

TESTING

> data Foo = A | B
>     deriving (Eq, Show)
> rulesx = [(A, [A,A]), (A, [B])]
> strx = [A,A,A,B,B] :: [Foo]
> envx1 = (rulesx, A, strx, [0.5, 0.5]) :: Env Foo
> envx = (rulesx, A, [strx], [0.5, 0.5]) :: EnvM Foo
> asx = makeAlphasM envx
> bsx = makeBetasM asx envx
> qsx = map (newQ' asx bsx envx) rulesx

> envx' = (rulesx, A, [strx], qsx) :: EnvM Foo
> envx1' = (rulesx, A, strx, qsx) :: Env Foo
> asx' = makeAlphasM envx'
> bsx' = makeBetasM asx' envx'
> qsx' = map (newQ' asx' bsx' envx') rulesx

newQ' as bs e@(rules, s, xs, phis) r@(lhs,rhs)

> testit = learnProbs' envx 100 0.1 0.1